# coding: utf-8

"""
    VMware Aria Automation Assembler IaaS API

    IAAS API is a RESTful service, which allows users to execute provisioning related UI actions via an API.  This page describes the RESTful APIs for IAAS API. The APIs facilitate CRUD operations on the various resources and entities used throughout VMware Aria Automation Assembler(Cloud Accounts, Cloud zones, Computes, Mappings, etc.) and allows operations on them (creating a cloud account, patching a machine, creating image progile, etc.).  The APIs that list collections of resources also support OData like implementation. Below query params can be used across different IAAS API endpoints  Example: 1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.     ```/iaas/api/cloud-accounts?$orderby=name%20desc```  2. `$top` -  number of records you want to get.     ```/iaas/api/cloud-accounts?$top=20```  3. `$skip` -  number of records you want to skip.      ```/iaas/api/cloud-accounts?$skip=10```  4. `$select` - select a subset of properties to include in the response.        ```/project-service/api/projects?$top=10&$skip=2```  5. `$filter` -  filter the results by a specified predicate expression. Operators: eq, ne, and, or.\\     ```/iaas/api/cloud-accounts?$filter=name%20eq%20'ABC*'``` - name starts with 'ABC'\\     ```/iaas/api/cloud-accounts?$filter=name%20eq%20'*ABC*'``` - name contains 'ABC'\\     ```/iaas/api/cloud-accounts?$filter=name%20eq%20'*ABC'``` - name ends with 'ABC'\\     /iaas/api/projects and /iaas/api/deployments support different format for partial match:\\     ```/iaas/api/projects?$filter=startswith(name, 'ABC')``` - name starts with 'ABC'\\     ```/iaas/api/projects?$filter=substringof('ABC', name``` - name contains 'ABC'\\     ```/iaas/api/projects?$filter=endswith(name, 'ABC')``` - name ends with 'ABC'\\     ```/iaas/api/cloud-accounts?$filter=name%20ne%20'example-cloud-account'%20or%20customProperties.isExternal%20eq%20'false'```  6. `$count` -  flag which when specified, regardless of the assigned value, shows the total number of records. If the collection has a filter it shows the number of records matching the filter.\\     ```/iaas/api/cloud-accounts?$count=true```   # noqa: E501

    OpenAPI spec version: 2021-07-15
    Contact: sales@vmware.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class StorageProfileAwsSpecification(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'name': 'str',
        'description': 'str',
        'default_item': 'bool',
        'supports_encryption': 'bool',
        'tags': 'list[IaasapistorageprofilesidTags]',
        'device_type': 'str',
        'volume_type': 'str',
        'iops': 'str',
        'region_id': 'str'
    }

    attribute_map = {
        'name': 'name',
        'description': 'description',
        'default_item': 'defaultItem',
        'supports_encryption': 'supportsEncryption',
        'tags': 'tags',
        'device_type': 'deviceType',
        'volume_type': 'volumeType',
        'iops': 'iops',
        'region_id': 'regionId'
    }

    def __init__(self, name=None, description=None, default_item=None, supports_encryption=None, tags=None, device_type=None, volume_type=None, iops=None, region_id=None):  # noqa: E501
        """StorageProfileAwsSpecification - a model defined in Swagger"""  # noqa: E501
        self._name = None
        self._description = None
        self._default_item = None
        self._supports_encryption = None
        self._tags = None
        self._device_type = None
        self._volume_type = None
        self._iops = None
        self._region_id = None
        self.discriminator = None
        self.name = name
        if description is not None:
            self.description = description
        if default_item is not None:
            self.default_item = default_item
        if supports_encryption is not None:
            self.supports_encryption = supports_encryption
        if tags is not None:
            self.tags = tags
        self.device_type = device_type
        if volume_type is not None:
            self.volume_type = volume_type
        if iops is not None:
            self.iops = iops
        self.region_id = region_id

    @property
    def name(self):
        """Gets the name of this StorageProfileAwsSpecification.  # noqa: E501

        A human-friendly name used as an identifier in APIs that support this option.  # noqa: E501

        :return: The name of this StorageProfileAwsSpecification.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this StorageProfileAwsSpecification.

        A human-friendly name used as an identifier in APIs that support this option.  # noqa: E501

        :param name: The name of this StorageProfileAwsSpecification.  # noqa: E501
        :type: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def description(self):
        """Gets the description of this StorageProfileAwsSpecification.  # noqa: E501

        A human-friendly description.  # noqa: E501

        :return: The description of this StorageProfileAwsSpecification.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this StorageProfileAwsSpecification.

        A human-friendly description.  # noqa: E501

        :param description: The description of this StorageProfileAwsSpecification.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def default_item(self):
        """Gets the default_item of this StorageProfileAwsSpecification.  # noqa: E501

        Indicates if a storage profile is default or not.  # noqa: E501

        :return: The default_item of this StorageProfileAwsSpecification.  # noqa: E501
        :rtype: bool
        """
        return self._default_item

    @default_item.setter
    def default_item(self, default_item):
        """Sets the default_item of this StorageProfileAwsSpecification.

        Indicates if a storage profile is default or not.  # noqa: E501

        :param default_item: The default_item of this StorageProfileAwsSpecification.  # noqa: E501
        :type: bool
        """

        self._default_item = default_item

    @property
    def supports_encryption(self):
        """Gets the supports_encryption of this StorageProfileAwsSpecification.  # noqa: E501

        Indicates whether this storage profile supports encryption or not.  # noqa: E501

        :return: The supports_encryption of this StorageProfileAwsSpecification.  # noqa: E501
        :rtype: bool
        """
        return self._supports_encryption

    @supports_encryption.setter
    def supports_encryption(self, supports_encryption):
        """Sets the supports_encryption of this StorageProfileAwsSpecification.

        Indicates whether this storage profile supports encryption or not.  # noqa: E501

        :param supports_encryption: The supports_encryption of this StorageProfileAwsSpecification.  # noqa: E501
        :type: bool
        """

        self._supports_encryption = supports_encryption

    @property
    def tags(self):
        """Gets the tags of this StorageProfileAwsSpecification.  # noqa: E501

        A list of tags that represent the capabilities of this storage profile  # noqa: E501

        :return: The tags of this StorageProfileAwsSpecification.  # noqa: E501
        :rtype: list[IaasapistorageprofilesidTags]
        """
        return self._tags

    @tags.setter
    def tags(self, tags):
        """Sets the tags of this StorageProfileAwsSpecification.

        A list of tags that represent the capabilities of this storage profile  # noqa: E501

        :param tags: The tags of this StorageProfileAwsSpecification.  # noqa: E501
        :type: list[IaasapistorageprofilesidTags]
        """

        self._tags = tags

    @property
    def device_type(self):
        """Gets the device_type of this StorageProfileAwsSpecification.  # noqa: E501

        Indicates the type of storage.  # noqa: E501

        :return: The device_type of this StorageProfileAwsSpecification.  # noqa: E501
        :rtype: str
        """
        return self._device_type

    @device_type.setter
    def device_type(self, device_type):
        """Sets the device_type of this StorageProfileAwsSpecification.

        Indicates the type of storage.  # noqa: E501

        :param device_type: The device_type of this StorageProfileAwsSpecification.  # noqa: E501
        :type: str
        """
        if device_type is None:
            raise ValueError("Invalid value for `device_type`, must not be `None`")  # noqa: E501

        self._device_type = device_type

    @property
    def volume_type(self):
        """Gets the volume_type of this StorageProfileAwsSpecification.  # noqa: E501

        Indicates the type of volume associated with type of storage.  # noqa: E501

        :return: The volume_type of this StorageProfileAwsSpecification.  # noqa: E501
        :rtype: str
        """
        return self._volume_type

    @volume_type.setter
    def volume_type(self, volume_type):
        """Sets the volume_type of this StorageProfileAwsSpecification.

        Indicates the type of volume associated with type of storage.  # noqa: E501

        :param volume_type: The volume_type of this StorageProfileAwsSpecification.  # noqa: E501
        :type: str
        """

        self._volume_type = volume_type

    @property
    def iops(self):
        """Gets the iops of this StorageProfileAwsSpecification.  # noqa: E501

        Indicates maximum I/O operations per second.  # noqa: E501

        :return: The iops of this StorageProfileAwsSpecification.  # noqa: E501
        :rtype: str
        """
        return self._iops

    @iops.setter
    def iops(self, iops):
        """Sets the iops of this StorageProfileAwsSpecification.

        Indicates maximum I/O operations per second.  # noqa: E501

        :param iops: The iops of this StorageProfileAwsSpecification.  # noqa: E501
        :type: str
        """

        self._iops = iops

    @property
    def region_id(self):
        """Gets the region_id of this StorageProfileAwsSpecification.  # noqa: E501

        A link to the region that is associated with the storage profile.  # noqa: E501

        :return: The region_id of this StorageProfileAwsSpecification.  # noqa: E501
        :rtype: str
        """
        return self._region_id

    @region_id.setter
    def region_id(self, region_id):
        """Sets the region_id of this StorageProfileAwsSpecification.

        A link to the region that is associated with the storage profile.  # noqa: E501

        :param region_id: The region_id of this StorageProfileAwsSpecification.  # noqa: E501
        :type: str
        """
        if region_id is None:
            raise ValueError("Invalid value for `region_id`, must not be `None`")  # noqa: E501

        self._region_id = region_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(StorageProfileAwsSpecification, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, StorageProfileAwsSpecification):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
